<script type="text/javascript" src="../../lib/sc-analysis.js"></script>
<link rel="import" href="../../bower_components/iron-signals/iron-signals.html">
<link rel="import" href="../../bower_components/iron-ajax/iron-ajax.html">

<dom-module id="sc-schema">

    <template>
        <iron-signals on-iron-signal-edit-label="openEditLabelDialog"></iron-signals>
        <iron-signals on-iron-signal-load-new-analysis="handleNewAnalysis"></iron-signals>
        <iron-signals on-iron-signal-add-label="handleAddLabelSignal"></iron-signals>
        <iron-signals on-iron-signal-delete-label="handleDeleteLabelSignal"></iron-signals>
        <iron-signals on-iron-signal-label-has-changed="handleLabelHasChangedSignal"></iron-signals>
        <iron-signals on-iron-signal-score-ready="handleScoreReady"></iron-signals>
        <iron-ajax
            auto
            url={{src}}
            handle-as="json"
            on-response="getLabels"
            debounce-duration="300"></iron-ajax>
        <iron-ajax
                id="AjaxPost"
                url={{analysesUrl}}
                method="POST"
                content-type="application/json"
                handle-as="json"
                ></iron-ajax>
    </template>

    <script>

        Polymer({

            is: 'sc-schema',

            properties: {
                src: String,
                label: Object
            },

            ready: function () {
                this._waitForNewAnalysis = true;
            },

            openEditLabelDialog (e, detail) {
                this.label = this.schema.getLabel(detail.id)
                this.labelid = detail.id;
                this.fire(
                    'iron-signal',
                    {
                        name: 'show-label-to-edit',
                        data: {
                            id: this.labelid,
                            label: this.label
                        }
                    }
                )
            },

            _sendLabels: function() {
                if (this.labels == undefined) {
                    return;
                }
                let i = 1;
                for (let item of this.labels) {
                    var label = new scAnalysis.Label (item.start, item.duration, item.type, item.tag, item.staff);
                    let id = "label" + i
                    this.schema.addLabel("label" + i, label)
                    i++;
                    this.fire(
                        'iron-signal',
                        {
                            name: 'add-label',
                            data:  {
                                start: label.start,
                                duration: label.duration,
                                labelType: label.type,
                                tag: label.tag,
                                staffIndex: label.staff,
                                id: id,
                                sender: "schema"
                            }
                        }
                    );
                }
            },

            getLabels: function (data) {
                this.labels =  data.detail.response.labels;
                this.schema = new scAnalysis.Schema();
                this.fire(
                    'iron-signal',
                    {
                        name: 'clear-labels'
                    }
                );
                this._sendLabels()
                this._waitForNewAnalysis = false;
            },

            handleNewAnalysis: function (e, detail) {
                if (this.src != detail.url) {
                    this.src = detail.url
                    this._waitForNewAnalysis = true;
                    this.fire(
                        'iron-signal',
                        {
                            name: 'clear-labels'
                        }
                    );
                }
            },

            handleScoreReady: function (e, detail, sender) {
                if (!this._waitForNewAnalysis) {
                    this._sendLabels()
                }
            },

            handleAddLabelSignal: function (e, detail, sender) {
                if (detail.sender == "schema") {
                    return;
                }
                var label = new scAnalysis.Label (detail.start, detail.duration, detail.labelType, detail.tag, detail.staffIndex);
                this.schema.addLabel(detail.id, label);
                this.fire(
                    'iron-signal',
                    {
                        name: 'debug',
                        data: this.schema.toString()
                    }
                );
            },

            handleDeleteLabelSignal: function (e, detail, sender) {
                this.schema.deleteLabel(detail.labelId);
                this.fire(
                    'iron-signal',
                    {
                        name: 'debug',
                        data: this.schema.toString()
                    }
                );
            },

            handleLabelHasChangedSignal: function (e, detail, sender) {
                this.label = this.schema.getLabel(detail.id)
                if (detail.duration) {
                    // use of this.set() to make the sub path 'label.duration' observable
                    // so the databinding works
                    this.set('label.duration', detail.duration);
                }
                this.set('label.start', detail.start);
                if (detail.tag) {
                    this.set('label.tag', detail.tag);
                }
                if (detail.type) {
                    this.set('label.type', detail.type);
                }
                this.fire(
                    'iron-signal',
                    {
                        name: 'debug',
                        data: this.schema.toString()
                    }
                );
            },

            toJson: function () {
                return this.schema.toJson();
            },

            saveAs: function (name) {
                this.$.AjaxPost.body = { "name": name + ".dez", "content": this.schema.toJson() };
                var split = this.src.split("/analyses/");
                this.analysesUrl = split[0] + "/analyses/";
                this.$.AjaxPost.generateRequest();
            },

        });

    </script>

</dom-module>
